USE COWS
GO
DECLARE @Table Table (SM_ID INT,FLAG INT DEFAULT(0))
INSERT INTO @Table (SM_ID)
Select DISTINCT lsm.SM_ID 
	From	dbo.ACT_TASK act WITH (NOLOCK) 
Inner Join	dbo.ORDR odr WITH (NOLOCK) ON act.ORDR_ID = odr.ORDR_ID
Left Join	dbo.LK_PPRT lp WITH (NOLOCK) ON lp.PPRT_ID = odr.PPRT_ID
Left Join	dbo.LK_SM lsm WITH (NOLOCK) ON lsm.SM_ID = lp.SM_ID
	WHERE	act.TASK_ID = 213 
		AND act.STUS_ID = 0
		AND ISNULL(lp.SM_ID,0) != 0

--Select * From @Table ORDER BY SM_ID

DECLARE @SMProf TABLE (SM_ID INT, WG_PTRN_ID INT, WG_PROF_ID INT)
INSERT INTO @SMProf (SM_ID,WG_PTRN_ID,WG_PROF_ID)
SELECT t.SM_ID,wptsm.WG_PTRN_ID, wptsm.DESRD_WG_PROF_ID
					FROM	dbo.SM sm WITH (NOLOCK)
				INNER JOIN	dbo.WG_PTRN_SM	wptsm WITH (NOLOCK) ON wptsm.WG_PTRN_ID = sm.DESRD_WG_PTRN_ID
				INNER JOIN	dbo.WG_PROF_SM	wpfsm WITH (NOLOCK) ON wpfsm.WG_PROF_ID = wptsm.DESRD_WG_PROF_ID				
				INNER JOIN  @Table t ON t.SM_ID = sm.SM_ID
					WHERE 	wpfsm.DESRD_TASK_ID = 213



--SELECT * FROM @SMProf ORDER BY SM_ID 
DECLARE @todr TABLE (FTN INT, ORDR_ID INT, WG_PTRN_ID INT, WG_PROF_ID INT, SM_ID INT)

INSERT INTO @todr(FTN,ORDR_ID,WG_PTRN_ID,WG_PROF_ID,SM_ID)
SELECT ISNULL(fsa.FTN,odr.ORDR_ID),odr.ORDR_ID,smp.WG_PTRN_ID,smp.WG_PROF_ID,smp.SM_ID
	From	dbo.ORDR odr WITH (NOLOCK)
INNER JOIN	dbo.LK_PPRT lp WITH (NOLOCK) ON odr.PPRT_ID = lp.PPRT_ID
INNER JOIN	@SMProf smp ON smp.SM_ID = lp.SM_ID
INNER JOIN	dbo.ACT_TASK at WITH (NOLOCK) ON at.ORDR_ID = odr.ORDR_ID 
LEFT JOIN	dbo.FSA_ORDR fsa WITH (NOLOCK) ON fsa.ORDR_ID = odr.ORDR_ID
	WHERE	at.TASK_ID	=	213
		AND	at.STUS_ID	=	0
		
SELECT * FROM @todr Order by ORDR_ID

INSERT INTO WG_PTRN_STUS (ORDR_ID,WG_PTRN_ID,STUS_ID,CREAT_DT)
SELECT tdr.ORDR_ID,tdr.WG_PTRN_ID,0, GETDATE()
	FROM @todr tdr
	WHERE NOT EXISTS
			(
				SELECT 'X'
					FROM dbo.WG_PTRN_STUS wpt WITH (NOLOCK)
					WHERE	wpt.ORDR_ID		=	tdr.ORDR_ID
						AND	wpt.WG_PTRN_ID	=	tdr.WG_PTRN_ID
			)
	--Order by ORDR_ID
	
INSERT INTO WG_PROF_STUS (ORDR_ID,WG_PROF_ID,WG_PTRN_ID,STUS_ID,CREAT_DT)
SELECT tdr.ORDR_ID,tdr.WG_PROF_ID,tdr.WG_PTRN_ID,0, GETDATE()
	FROM @todr tdr
	WHERE NOT EXISTS
			(
				SELECT 'X'
					FROM dbo.WG_PROF_STUS wpf WITH (NOLOCK)
					WHERE	wpf.ORDR_ID		=	tdr.ORDR_ID
						AND	wpf.WG_PTRN_ID	=	tdr.WG_PTRN_ID
						AND wpf.WG_PROF_ID	=	tdr.WG_PROF_ID
			)
	--Order by ORDR_ID

UPDATE at
	SET WG_PROF_ID = tdr.WG_PROF_ID
	FROM	dbo.ACT_TASK at WITH (ROWLOCK)
INNER JOIN	@todr tdr ON at.ORDR_ID = tdr.ORDR_ID
	WHERE	at.TASK_ID = 213
		AND at.STUS_ID = 0

